/* DateTime.c generated by valac 0.38.4, the Vala compiler
 * generated from DateTime.vala, do not modify */

/*
 *  Copyright (C) 2012-2017 Granite Developers
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>
#include <gio/gio.h>

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))



gchar* granite_date_time_get_default_time_format (gboolean is_12h, gboolean with_second);
gchar* granite_date_time_get_relative_datetime (GDateTime* date_time);
gboolean granite_date_time_is_same_day (GDateTime* day1, GDateTime* day2);
gboolean granite_date_time_is_clock_format_12h (void);
gchar* granite_date_time_get_default_date_format (gboolean with_weekday, gboolean with_day, gboolean with_year);
gchar* granite_date_time_seconds_to_time (gint seconds);
gchar* granite_date_time_normalize_time (gint time);


/**
     * Gets a default translated time format.
     * The function constructs a new string interpreting the //is_12h// and //with_second// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * The returned string is formatted and translated. This function is mostly used to display
     * the time in various user interfaces like the time displayed in the top panel.
     *
     * @param is_12h if the returned string should be formatted in 12h format
     * @param with_second if the returned string should include seconds
     *
     * @return the formatted and located time string.
     */
gchar* granite_date_time_get_default_time_format (gboolean is_12h, gboolean with_second) {
	gchar* result = NULL;
	gboolean _tmp0_;
	_tmp0_ = is_12h;
	if (_tmp0_ == TRUE) {
		gboolean _tmp1_;
		_tmp1_ = with_second;
		if (_tmp1_ == TRUE) {
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("%l:%M:%S %p"));
			result = _tmp2_;
			return result;
		} else {
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("%l:%M %p"));
			result = _tmp3_;
			return result;
		}
	} else {
		gboolean _tmp4_;
		_tmp4_ = with_second;
		if (_tmp4_ == TRUE) {
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("%H:%M:%S"));
			result = _tmp5_;
			return result;
		} else {
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("%H:%M"));
			result = _tmp6_;
			return result;
		}
	}
}


/**
     * Compares a {@link GLib.DateTime} to {@link GLib.DateTime.now_local} and returns a location, relative date and
     * time string. Results appear as natural-language strings like "Now", "5m ago", "Yesterday"
     *
     * @param date_time a {@link GLib.DateTime} to compare against {@link GLib.DateTime.now_local}
     *
     * @return a localized, relative date and time string
     */
gchar* granite_date_time_get_relative_datetime (GDateTime* date_time) {
	gchar* result = NULL;
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GTimeSpan _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gboolean _tmp6_;
	g_return_val_if_fail (date_time != NULL, NULL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = now;
	_tmp2_ = date_time;
	_tmp3_ = g_date_time_difference (_tmp1_, _tmp2_);
	diff = _tmp3_;
	_tmp4_ = date_time;
	_tmp5_ = now;
	_tmp6_ = granite_date_time_is_same_day (_tmp4_, _tmp5_);
	if (_tmp6_) {
		GTimeSpan _tmp7_;
		GDateTime* _tmp33_;
		gboolean _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		_tmp7_ = diff;
		if (_tmp7_ > ((GTimeSpan) 0)) {
			GTimeSpan _tmp8_;
			_tmp8_ = diff;
			if (_tmp8_ < G_TIME_SPAN_MINUTE) {
				gchar* _tmp9_;
				_tmp9_ = g_strdup (_ ("Now"));
				result = _tmp9_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				GTimeSpan _tmp10_;
				_tmp10_ = diff;
				if (_tmp10_ < G_TIME_SPAN_HOUR) {
					GTimeSpan minutes = 0LL;
					GTimeSpan _tmp11_;
					GTimeSpan _tmp12_;
					GTimeSpan _tmp13_;
					gchar* _tmp14_;
					_tmp11_ = diff;
					minutes = _tmp11_ / G_TIME_SPAN_MINUTE;
					_tmp12_ = minutes;
					_tmp13_ = minutes;
					_tmp14_ = g_strdup_printf (ngettext ("%dm ago", "%dm ago", (gulong) _tmp12_), (gint) _tmp13_);
					result = _tmp14_;
					_g_date_time_unref0 (now);
					return result;
				} else {
					GTimeSpan _tmp15_;
					_tmp15_ = diff;
					if (_tmp15_ < (12 * G_TIME_SPAN_HOUR)) {
						gint rounded = 0;
						GTimeSpan _tmp16_;
						gdouble _tmp17_;
						gint _tmp18_;
						gint _tmp19_;
						gchar* _tmp20_;
						_tmp16_ = diff;
						_tmp17_ = round (((gdouble) _tmp16_) / G_TIME_SPAN_HOUR);
						rounded = (gint) _tmp17_;
						_tmp18_ = rounded;
						_tmp19_ = rounded;
						_tmp20_ = g_strdup_printf (ngettext ("%dh ago", "%dh ago", (gulong) _tmp18_), _tmp19_);
						result = _tmp20_;
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
		} else {
			GTimeSpan _tmp21_;
			GTimeSpan _tmp22_;
			_tmp21_ = diff;
			diff = -1 * _tmp21_;
			_tmp22_ = diff;
			if (_tmp22_ < G_TIME_SPAN_HOUR) {
				GTimeSpan minutes = 0LL;
				GTimeSpan _tmp23_;
				GTimeSpan _tmp24_;
				GTimeSpan _tmp25_;
				gchar* _tmp26_;
				_tmp23_ = diff;
				minutes = _tmp23_ / G_TIME_SPAN_MINUTE;
				_tmp24_ = minutes;
				_tmp25_ = minutes;
				_tmp26_ = g_strdup_printf (ngettext ("in %dm", "in %dm", (gulong) _tmp24_), (gint) _tmp25_);
				result = _tmp26_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				GTimeSpan _tmp27_;
				_tmp27_ = diff;
				if (_tmp27_ < (12 * G_TIME_SPAN_HOUR)) {
					gint rounded = 0;
					GTimeSpan _tmp28_;
					gdouble _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					gchar* _tmp32_;
					_tmp28_ = diff;
					_tmp29_ = round (((gdouble) _tmp28_) / G_TIME_SPAN_HOUR);
					rounded = (gint) _tmp29_;
					_tmp30_ = rounded;
					_tmp31_ = rounded;
					_tmp32_ = g_strdup_printf (ngettext ("in %dh", "in %dh", (gulong) _tmp30_), _tmp31_);
					result = _tmp32_;
					_g_date_time_unref0 (now);
					return result;
				}
			}
		}
		_tmp33_ = date_time;
		_tmp34_ = granite_date_time_is_clock_format_12h ();
		_tmp35_ = granite_date_time_get_default_time_format (_tmp34_, FALSE);
		_tmp36_ = _tmp35_;
		_tmp37_ = g_date_time_format (_tmp33_, _tmp36_);
		_tmp38_ = _tmp37_;
		_g_free0 (_tmp36_);
		result = _tmp38_;
		_g_date_time_unref0 (now);
		return result;
	} else {
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
		GDateTime* _tmp41_;
		GDateTime* _tmp42_;
		gboolean _tmp43_;
		gboolean _tmp44_;
		_tmp39_ = date_time;
		_tmp40_ = g_date_time_add_days (_tmp39_, 1);
		_tmp41_ = _tmp40_;
		_tmp42_ = now;
		_tmp43_ = granite_date_time_is_same_day (_tmp41_, _tmp42_);
		_tmp44_ = _tmp43_;
		_g_date_time_unref0 (_tmp41_);
		if (_tmp44_) {
			gchar* _tmp45_;
			_tmp45_ = g_strdup (_ ("Yesterday"));
			result = _tmp45_;
			_g_date_time_unref0 (now);
			return result;
		} else {
			GDateTime* _tmp46_;
			GDateTime* _tmp47_;
			GDateTime* _tmp48_;
			GDateTime* _tmp49_;
			gboolean _tmp50_;
			gboolean _tmp51_;
			_tmp46_ = date_time;
			_tmp47_ = g_date_time_add_days (_tmp46_, -1);
			_tmp48_ = _tmp47_;
			_tmp49_ = now;
			_tmp50_ = granite_date_time_is_same_day (_tmp48_, _tmp49_);
			_tmp51_ = _tmp50_;
			_g_date_time_unref0 (_tmp48_);
			if (_tmp51_) {
				gchar* _tmp52_;
				_tmp52_ = g_strdup (_ ("Tomorrow"));
				result = _tmp52_;
				_g_date_time_unref0 (now);
				return result;
			} else {
				gboolean _tmp53_ = FALSE;
				GTimeSpan _tmp54_;
				_tmp54_ = diff;
				if (_tmp54_ < (6 * G_TIME_SPAN_DAY)) {
					GTimeSpan _tmp55_;
					_tmp55_ = diff;
					_tmp53_ = _tmp55_ > (-6 * G_TIME_SPAN_DAY);
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					GDateTime* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
					gchar* _tmp60_;
					_tmp56_ = date_time;
					_tmp57_ = granite_date_time_get_default_date_format (TRUE, FALSE, FALSE);
					_tmp58_ = _tmp57_;
					_tmp59_ = g_date_time_format (_tmp56_, _tmp58_);
					_tmp60_ = _tmp59_;
					_g_free0 (_tmp58_);
					result = _tmp60_;
					_g_date_time_unref0 (now);
					return result;
				} else {
					GDateTime* _tmp61_;
					gint _tmp62_;
					GDateTime* _tmp63_;
					gint _tmp64_;
					_tmp61_ = date_time;
					_tmp62_ = g_date_time_get_year (_tmp61_);
					_tmp63_ = now;
					_tmp64_ = g_date_time_get_year (_tmp63_);
					if (_tmp62_ == _tmp64_) {
						GDateTime* _tmp65_;
						gchar* _tmp66_;
						gchar* _tmp67_;
						gchar* _tmp68_;
						gchar* _tmp69_;
						_tmp65_ = date_time;
						_tmp66_ = granite_date_time_get_default_date_format (FALSE, TRUE, FALSE);
						_tmp67_ = _tmp66_;
						_tmp68_ = g_date_time_format (_tmp65_, _tmp67_);
						_tmp69_ = _tmp68_;
						_g_free0 (_tmp67_);
						result = _tmp69_;
						_g_date_time_unref0 (now);
						return result;
					} else {
						GDateTime* _tmp70_;
						gchar* _tmp71_;
						_tmp70_ = date_time;
						_tmp71_ = g_date_time_format (_tmp70_, "%x");
						result = _tmp71_;
						_g_date_time_unref0 (now);
						return result;
					}
				}
			}
		}
	}
	_g_date_time_unref0 (now);
}


/**
     * Gets the //clock-format// key from //org.gnome.desktop.interface// schema
     * and determines if the clock format is 12h based
     *
     * @return true if the clock format is 12h based, false otherwise.
     */
static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = needle;
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
	result = _tmp1_ != NULL;
	return result;
}


gboolean granite_date_time_is_clock_format_12h (void) {
	gboolean result = FALSE;
	GSettings* h24_settings = NULL;
	GSettings* _tmp0_;
	gchar* format = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = g_settings_new ("org.gnome.desktop.interface");
	h24_settings = _tmp0_;
	_tmp1_ = g_settings_get_string (h24_settings, "clock-format");
	format = _tmp1_;
	_tmp2_ = string_contains (format, "12h");
	result = _tmp2_;
	_g_free0 (format);
	_g_object_unref0 (h24_settings);
	return result;
}


/**
     * Compare two {@link GLib.DateTime} and return true if they occur on the same day of the same year
     *
     * @param day1 a {@link GLib.DateTime} to compare against day2
     * @param day2 a {@link GLib.DateTime} to compare against day1
     *
     * @return true if day1 and day2 occur on the same day of the same year. False otherwise
     */
gboolean granite_date_time_is_same_day (GDateTime* day1, GDateTime* day2) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GDateTime* _tmp1_;
	gint _tmp2_;
	GDateTime* _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (day1 != NULL, FALSE);
	g_return_val_if_fail (day2 != NULL, FALSE);
	_tmp1_ = day1;
	_tmp2_ = g_date_time_get_day_of_year (_tmp1_);
	_tmp3_ = day2;
	_tmp4_ = g_date_time_get_day_of_year (_tmp3_);
	if (_tmp2_ == _tmp4_) {
		GDateTime* _tmp5_;
		gint _tmp6_;
		GDateTime* _tmp7_;
		gint _tmp8_;
		_tmp5_ = day1;
		_tmp6_ = g_date_time_get_year (_tmp5_);
		_tmp7_ = day2;
		_tmp8_ = g_date_time_get_year (_tmp7_);
		_tmp0_ = _tmp6_ == _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


/**
     * Gets the default translated date format.
     * The function constructs a new string interpreting the //with_weekday//, //with_day// and //with_year// parameters
     * so that it can be used with formatting functions like {@link GLib.DateTime.format}.
     *
     * As the {@link Granite.DateTime.get_default_time_format}, the returned string is formatted, translated and is also mostly used to display
     * the date in various user interfaces like the date displayed in the top panel.
     *
     * @param with_weekday if the returned string should contain the abbreviated weekday name
     * @param with_day if the returned string should contain contain the day of the month as a decimal number (range 1 to 31)
     * @param with_year if the returned string should contain the year as a decimal number including the century
     *
     * @return returns the formatted and located date string. If for some reason, the function could not determine the format to use,
     *         an empty string will be returned.
     */
gchar* granite_date_time_get_default_date_format (gboolean with_weekday, gboolean with_day, gboolean with_year) {
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gchar* _tmp48_;
	_tmp2_ = with_weekday;
	if (_tmp2_ == TRUE) {
		gboolean _tmp3_;
		_tmp3_ = with_day;
		_tmp1_ = _tmp3_ == TRUE;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp4_;
		_tmp4_ = with_year;
		_tmp0_ = _tmp4_ == TRUE;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp5_;
		_tmp5_ = g_strdup (_ ("%a %b %e %Y"));
		result = _tmp5_;
		return result;
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		_tmp8_ = with_weekday;
		if (_tmp8_ == FALSE) {
			gboolean _tmp9_;
			_tmp9_ = with_day;
			_tmp7_ = _tmp9_ == TRUE;
		} else {
			_tmp7_ = FALSE;
		}
		if (_tmp7_) {
			gboolean _tmp10_;
			_tmp10_ = with_year;
			_tmp6_ = _tmp10_ == TRUE;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			gchar* _tmp11_;
			_tmp11_ = g_strdup (_ ("%b %e %Y"));
			result = _tmp11_;
			return result;
		} else {
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
			gboolean _tmp14_;
			_tmp14_ = with_weekday;
			if (_tmp14_ == FALSE) {
				gboolean _tmp15_;
				_tmp15_ = with_day;
				_tmp13_ = _tmp15_ == FALSE;
			} else {
				_tmp13_ = FALSE;
			}
			if (_tmp13_) {
				gboolean _tmp16_;
				_tmp16_ = with_year;
				_tmp12_ = _tmp16_ == TRUE;
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				gchar* _tmp17_;
				_tmp17_ = g_strdup (_ ("%Y"));
				result = _tmp17_;
				return result;
			} else {
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_;
				_tmp20_ = with_weekday;
				if (_tmp20_ == FALSE) {
					gboolean _tmp21_;
					_tmp21_ = with_day;
					_tmp19_ = _tmp21_ == TRUE;
				} else {
					_tmp19_ = FALSE;
				}
				if (_tmp19_) {
					gboolean _tmp22_;
					_tmp22_ = with_year;
					_tmp18_ = _tmp22_ == FALSE;
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					gchar* _tmp23_;
					_tmp23_ = g_strdup (_ ("%b %e"));
					result = _tmp23_;
					return result;
				} else {
					gboolean _tmp24_ = FALSE;
					gboolean _tmp25_ = FALSE;
					gboolean _tmp26_;
					_tmp26_ = with_weekday;
					if (_tmp26_ == TRUE) {
						gboolean _tmp27_;
						_tmp27_ = with_day;
						_tmp25_ = _tmp27_ == FALSE;
					} else {
						_tmp25_ = FALSE;
					}
					if (_tmp25_) {
						gboolean _tmp28_;
						_tmp28_ = with_year;
						_tmp24_ = _tmp28_ == TRUE;
					} else {
						_tmp24_ = FALSE;
					}
					if (_tmp24_) {
						gchar* _tmp29_;
						_tmp29_ = g_strdup (_ ("%a %Y"));
						result = _tmp29_;
						return result;
					} else {
						gboolean _tmp30_ = FALSE;
						gboolean _tmp31_ = FALSE;
						gboolean _tmp32_;
						_tmp32_ = with_weekday;
						if (_tmp32_ == TRUE) {
							gboolean _tmp33_;
							_tmp33_ = with_day;
							_tmp31_ = _tmp33_ == FALSE;
						} else {
							_tmp31_ = FALSE;
						}
						if (_tmp31_) {
							gboolean _tmp34_;
							_tmp34_ = with_year;
							_tmp30_ = _tmp34_ == FALSE;
						} else {
							_tmp30_ = FALSE;
						}
						if (_tmp30_) {
							gchar* _tmp35_;
							_tmp35_ = g_strdup (_ ("%a"));
							result = _tmp35_;
							return result;
						} else {
							gboolean _tmp36_ = FALSE;
							gboolean _tmp37_ = FALSE;
							gboolean _tmp38_;
							_tmp38_ = with_weekday;
							if (_tmp38_ == TRUE) {
								gboolean _tmp39_;
								_tmp39_ = with_day;
								_tmp37_ = _tmp39_ == TRUE;
							} else {
								_tmp37_ = FALSE;
							}
							if (_tmp37_) {
								gboolean _tmp40_;
								_tmp40_ = with_year;
								_tmp36_ = _tmp40_ == FALSE;
							} else {
								_tmp36_ = FALSE;
							}
							if (_tmp36_) {
								gchar* _tmp41_;
								_tmp41_ = g_strdup (_ ("%a %b %e"));
								result = _tmp41_;
								return result;
							} else {
								gboolean _tmp42_ = FALSE;
								gboolean _tmp43_ = FALSE;
								gboolean _tmp44_;
								_tmp44_ = with_weekday;
								if (_tmp44_ == FALSE) {
									gboolean _tmp45_;
									_tmp45_ = with_day;
									_tmp43_ = _tmp45_ == FALSE;
								} else {
									_tmp43_ = FALSE;
								}
								if (_tmp43_) {
									gboolean _tmp46_;
									_tmp46_ = with_year;
									_tmp42_ = _tmp46_ == FALSE;
								} else {
									_tmp42_ = FALSE;
								}
								if (_tmp42_) {
									gchar* _tmp47_;
									_tmp47_ = g_strdup (_ ("%b"));
									result = _tmp47_;
									return result;
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp48_ = g_strdup ("");
	result = _tmp48_;
	return result;
}


gchar* granite_date_time_seconds_to_time (gint seconds) {
	gchar* result = NULL;
	gint hours = 0;
	gint _tmp0_;
	gchar* min = NULL;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* sec = NULL;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_;
	_tmp0_ = seconds;
	hours = _tmp0_ / 3600;
	_tmp1_ = seconds;
	_tmp2_ = granite_date_time_normalize_time ((_tmp1_ % 3600) / 60);
	min = _tmp2_;
	_tmp3_ = seconds;
	_tmp4_ = granite_date_time_normalize_time (_tmp3_ % 60);
	sec = _tmp4_;
	_tmp5_ = hours;
	if (_tmp5_ > 0) {
		gint _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp6_ = hours;
		_tmp7_ = min;
		_tmp8_ = sec;
		_tmp9_ = g_strdup_printf ("%d:%s:%s", _tmp6_, _tmp7_, _tmp8_);
		result = _tmp9_;
		_g_free0 (sec);
		_g_free0 (min);
		return result;
	} else {
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp10_ = min;
		_tmp11_ = sec;
		_tmp12_ = g_strdup_printf ("%s:%s", _tmp10_, _tmp11_);
		result = _tmp12_;
		_g_free0 (sec);
		_g_free0 (min);
		return result;
	}
	_g_free0 (sec);
	_g_free0 (min);
}


gchar* granite_date_time_normalize_time (gint time) {
	gchar* result = NULL;
	gint _tmp0_;
	_tmp0_ = time;
	if (_tmp0_ < 10) {
		gint _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = time;
		_tmp2_ = g_strdup_printf ("0%d", _tmp1_);
		result = _tmp2_;
		return result;
	} else {
		gint _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = time;
		_tmp4_ = g_strdup_printf ("%d", _tmp3_);
		result = _tmp4_;
		return result;
	}
}



